import 'package:flutter/cupertino.dart';
import 'package:osam/domain/state/base_state.dart';

typedef BaseState Reducer<ST extends BaseState<ST>>(ST state);

class Event<ST extends BaseState<ST>> {
  final Reducer<ST> reducer;

  const Event({@required this.reducer});

  void call(ST state) => reducer?.call(state)?.update();

  String get log => this.toString();

  @override
  String toString() => 'Event type:${this.runtimeType}';
}
